package com.bgg.sfix;

import java.io.File;
import java.util.ArrayList;
import java.util.List;

import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.os.Environment;
import android.view.KeyEvent;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.AdapterView.OnItemClickListener;


public class ChooserDialog extends AlertDialog {
	private String sdcardDirectory = Environment.getExternalStorageDirectory().getAbsolutePath();
	private String currentDir="";
	private CustomAdapter adapter = null;
	private List<String> values= null;
    private List<Character> type = null;
    private TextView currDirView =null;
    protected ChooserDialog(Context context, final ChosenDirectoryListener listener) {
		super(context);
		AlertDialog.Builder alert = new AlertDialog.Builder(context);
        alert.setTitle("Seleziona la cartella"); //Set Alert dialog title here
        
        // Get the layout inflater
        LayoutInflater inflater = getLayoutInflater();
        // Inflate and set the layout for the dialog
        
        values= new ArrayList<String>();
        type = new ArrayList<Character>();
        currentDir=sdcardDirectory;
        getDirectories(values,type,currentDir);
        
        adapter = new CustomAdapter(context,values,type);
        View dialogview = inflater.inflate(R.layout.dialoglayout, null);
        currDirView =(TextView) dialogview.findViewById(R.id.currDirView);
        currDirView.setText(currentDir);
        ListView lv=(ListView) dialogview.findViewById(R.id.list);
        lv.setAdapter(adapter);
        lv.setOnItemClickListener(new OnItemClickListener(){
  		  public void onItemClick(AdapterView<?> parent, View view,
  	        int position, long id) {
  			  //al click di un'elemento della lista
  			  //se  una cartella -> update
  			// Navigate into the sub-directory
  			  if(type.get(position)=='d'){
  				  currentDir += "/" + values.get(position);
  				  updateDirectory();
              }
  		  }});
        alert.setView(dialogview);
        
        alert.setPositiveButton("OK", new DialogInterface.OnClickListener() {
	        public void onClick(DialogInterface dialog, int whichButton) {
	        	listener.onChosenDir(currentDir);
	          }
	    });

        alert.setNegativeButton("CANCEL", new DialogInterface.OnClickListener() {
          public void onClick(DialogInterface dialog, int whichButton) {
            // Canceled.
            dialog.cancel();
          }
        });
        AlertDialog alertDialog = alert.create();
        
        alertDialog.setOnKeyListener(new OnKeyListener(){
            @Override
            public boolean onKey(DialogInterface dialog, int keyCode, KeyEvent event){
                if (keyCode == KeyEvent.KEYCODE_BACK && event.getAction() == KeyEvent.ACTION_DOWN){
                    // Back button pressed
                    if ( currentDir.equals(sdcardDirectory) ){
                        // The very top level directory, do nothing
                        return false;
                    }
                    else{
                        // Navigate back to an upper directory
                        currentDir = new File(currentDir).getParent();
                        updateDirectory();
                    }
        
                    return true;
                }
                else{
                    return false;
                }
            }
        });
        
        alertDialog.show();
        
    }
    
    public interface ChosenDirectoryListener{
        public void onChosenDir(String chosenDir);
    }
   
    //Mette nella lista i nomi di tutti i file e cartelle contenuti in dir (non mostra i file nascosti)
    private boolean getDirectories(List<String> dirs, List<Character> type, String dir){
    	File dirFile = new File(dir);
        if (! dirFile.exists()){
            return false;
        }
        File [] files=dirFile.listFiles();
        for (int i=0;i<files.length;i++){
        	if(!files[i].isHidden()){
	          	if ( files[i].isDirectory()){
	           		type.add('d');
	                dirs.add( files[i].getName() );
	            }else{
	               	type.add('f');
	                dirs.add( files[i].getName());
	            }
          	}
        }
        return true;
    }
    
    //Aggiorna la lista per la nuova cartella cliccata
    private void updateDirectory()
    {
        values.clear();
        type.clear();
        getDirectories(values,type,currentDir);
        currDirView.setText(currentDir);
        adapter.notifyDataSetChanged();
    }
    }
	