package com.bgg.sfix;

import java.util.List;

import android.content.Context;
import android.graphics.Color;
import android.graphics.drawable.Drawable;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.TextView;

public class CustomAdapter extends ArrayAdapter<String> {
  private final Context context;
  private final List<String> values;
  private final List<Character> type;

  public CustomAdapter(Context context, List<String> values,List<Character> type) {
    super(context,android.R.layout.simple_list_item_1, values);
    this.context = context;
    this.values = values;
    this.type = type;
  }

  @Override
  public View getView(int position, View convertView, ViewGroup parent) {
    LayoutInflater inflater = (LayoutInflater) context
        .getSystemService(Context.LAYOUT_INFLATER_SERVICE);
    View rowView = inflater.inflate(android.R.layout.simple_list_item_1, parent, false);
    TextView textView = (TextView) rowView.findViewById(android.R.id.text1);
    textView.setTextColor(Color.WHITE);
    textView.setCompoundDrawablePadding(5);
    textView.setText(values.get(position));
    
    //Change the icon for file and folder
    if (type.get(position)=='d') {

    	Drawable drawable = context.getResources().getDrawable(R.drawable.folder);
    	textView.setCompoundDrawablesWithIntrinsicBounds(drawable,null,null,null);
    } else {
    	Drawable drawable = context.getResources().getDrawable(R.drawable.file);
    	textView.setCompoundDrawablesWithIntrinsicBounds(drawable,null,null,null);
    }

    return rowView;
  }
} 