package com.bgg.sfix;

import com.bgg.sfix.ProgressActivity.ResultData;

import android.os.Bundle;
import android.app.Activity;
import android.content.Intent;
import android.widget.ImageView;
import android.widget.TextView;

public class ReportActivity extends Activity {

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_report);
		Graphic.setdefaultFont(this,android.R.id.content,getBaseContext());
		ImageView iv=(ImageView)(findViewById(R.id.report));
		if(GetReportData().getErrors()==-1){
			iv.setImageResource(R.drawable.error);
			TextView messError = (TextView)(findViewById(R.id.textView_ReportActivity_StrMsgError));
			messError.setVisibility(1);
			messError.setText(" > " + GetReportData().getException());
		}
		else{
			iv.setImageResource(R.drawable.ok);
			TextView files_done = (TextView)(findViewById(R.id.textView_ReportActivity_FileDone));
			files_done.setText("Brani Rilevati: " + GetReportData().getDone());
			TextView files_errors = (TextView)(findViewById(R.id.textView_ReportActivity_FileErrors));
			files_errors.setText("Brani non Riconosciuti: " + GetReportData().getErrors());
			TextView files_recent = (TextView)(findViewById(R.id.textView_ReportActivity_nFilesRecent));
			files_recent.setText("Brani gi analizzati recentemente: "+ GetReportData().getJumpedFiles());
			TextView messError = (TextView)(findViewById(R.id.textView_ReportActivity_StrMsgError));
			messError.setVisibility(0);
		}
		
	}

	
	//al click del pulsante back torna al main
	@Override
	public void onBackPressed() {	
	    Intent intent = new Intent(getApplicationContext(), MainActivity.class);
	    intent.setFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP);
        startActivity(intent);
        finish ();
        
        return;
    }

	/**
	 * @return Il risultato dell'analisi compiuta nella progressActivity. I dati, infatti, vengono ricavati
	 * dall'intent passato da quest ultima.
	 */
	private ProgressActivity.ResultData GetReportData(){
		if(dataResult!=null) return dataResult;
		Intent data_passed = getIntent();
		dataResult = ProgressActivity.GetResultData_fromBundle(data_passed.getExtras());
		return dataResult;
	}
	
	private ResultData dataResult = null;
}
